<div class="tchat">
  <div class="messages"></div>
  <div class="typing">
    <svg
      class="typingBubble"
      data-name="typing bubble"
      xmlns="http://www.w3.org/2000/svg"
      viewBox="0 0 120 66"
    >
      <g id="bubble">
        <path
          class="cls-1"
          d="M152,166H108a29.848,29.848,0,0,1-16.03-4.647,10.993,10.993,0,1,1-12.7-16.692A30.008,30.008,0,0,1,108,106h44A30,30,0,0,1,152,166Zm-85,6a5,5,0,1,1,5-5A5,5,0,0,1,67,172Z"
          transform="translate(-62 -106)"
        />
      </g>
      <g>
        <circle class="dot" cx="46" cy="30" r="8" />
        <circle class="dot" cx="68" cy="30" r="8" />
        <circle class="dot" cx="90" cy="30" r="8" />
      </g>
    </svg>
    <div class="userTyping"></div>
  </div>
  <form class="sendMessage">
    <input
      type="text"
      class="sendInput"
      placeholder="Entrer votre message ici"
    />
    <button class="sendButton" type="submit">
      <svg viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg" fill="none">
        <path
          fill-rule="evenodd"
          d="M2.345 2.245a1 1 0 0 1 1.102-.14l18 9a1 1 0 0 1 0 1.79l-18 9a1 1 0 0 1-1.396-1.211L4.613 13H10a1 1 0 1 0 0-2H4.613L2.05 3.316a1 1 0 0 1 .294-1.071z"
          clip-rule="evenodd"
        />
      </svg>
    </button>
  </form>
</div>

<script src="/socket.io/socket.io.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/he/1.2.0/he.min.js"></script>

<script>
  const form = document.querySelector("form");
  const input = document.querySelector(".sendInput");
  const messages = document.querySelector(".messages");
  const typing = document.querySelector(".typing");
  const userTyping = document.querySelector(".userTyping");

  const socket = io.connect("http://localhost:8080");

  const { id: currentUserId } = JSON.parse(
    he.decode("<%= JSON.stringify(user) %>")
  );

  const addMessage = (message) => {
    const {
      user: { id, name, avatar },
      time,
      text,
      id: messageId,
    } = message;

    const isSelfMessage = id === currentUserId;

    // Change onClick function to delete message by another solution
    messages.innerHTML += `
        <div class="messageContainer" type="${isSelfMessage ? "self" : ""}">
          <img src="${avatar}" alt="avatar de ${name}" />
          <div class="message">
            <p class="text">${text}</p>
          </div>
          <div class="extra">
            <p>${name} - ${time}</p>
          </div>
          ${
            isSelfMessage
              ? `
          <svg
            viewBox="0 0 15 15"
            fill="none"
            xmlns="http://www.w3.org/2000/svg"
           onclick="socket.emit('delete_message', '${messageId}', '${currentUserId}')"
          >
          <path
            d="M4.5 3V1.5C4.5 0.947715 4.94772 0.5 5.5 0.5H9.5C10.0523 0.5 10.5 0.947715 10.5 1.5V3M0 3.5H15M1.5 3.5V13.5C1.5 14.0523 1.94772 14.5 2.5 14.5H12.5C13.0523 14.5 13.5 14.0523 13.5 13.5V3.5M7.5 7V12M4.5 9V12M10.5 9V12"
          />
        </svg>
          `
              : ""
          }
        </div>
      `;
    messages.scrollTop = messages.scrollHeight;
  };

  socket.on("chat_message", (listMessages) => {
    if (Array.isArray(listMessages)) {
      messages.innerHTML = "";
      for (const message of listMessages) {
        addMessage(message);
      }
    } else if (typeof listMessages === "object") {
      addMessage(listMessages);
    } else {
      console.error("Error: listMessages is not an array or an object");
    }
  });

  socket.on("typing", ({ users }) => {
    typing.style.display = users.length ? "flex" : "none";
    userTyping.innerHTML = "";
    for (const { name, avatar } of users) {
      userTyping.innerHTML += `<img src="${avatar}" alt="avatar de ${name}" />`;
    }
  });

  form.addEventListener(
    "submit",
    (e) => {
      e.preventDefault();
      if (!input.value) return;
      socket.emit("chat_message", {
        message: input.value,
      });
      input.value = "";
      return false;
    },
    false
  );

  input.addEventListener("focus", () => socket.emit("typing", true));
  input.addEventListener("blur", () => socket.emit("typing", false));

  window.addEventListener("beforeunload", () => {
    socket.emit("user_leave");
  });

  socket.emit("user_join");
</script>
